# utf8decode.rb

def utf8decode( str )
	unless @utf8decode_table then
		open( File.join( File.dirname( __FILE__ ), 'utf8decode.dat' ) ) do |f|
			@utf8decode_table = f.read( 65536*2 ).unpack( "v*" )
		end
	end
	invalidchr = 0x25a0
	table = [[ 0x7f, 0x00 ],
			 [ 0x1f, 0xc0 ],
			 [ 0x0f, 0xe0 ],
			 [ 0x07, 0xf0 ],
			 [ 0x03, 0xf8 ],
			 [ 0x01, 0xfc ]]
	r = ""
	i = 0
	while i < str.length do
		chr = str[i]
		i += 1
		t = 1
		while t < table.length do
			if chr < table[t][1] then
				break
			end
			t += 1
		end
		if t == table.length then
			return str
		end
		if (chr & (~table[t-1][0])) != table[t-1][1] then
			return str
		end
		ucs2 = chr & table[t-1][0]
		while t > 1 do
			chr = str[i]
			i += 1
			if (chr & 0xc0) != 0x80 then
				return str
			end
			chr &= 0x3f
			ucs2 <<= 6
			ucs2 |= chr
			t -= 1
		end
		if ucs2 > 0xffff then
			ucs2 = invalidchr
		end
		euc = @utf8decode_table[ucs2]
		if euc == 0 then
			case ucs2 
			when 0xff5e 
				euc = 0xa1c1
			when 0xff0d
				euc = 0xa1dd
			else
				euc = @utf8decode_table[invalidchr]
			end
		end
		if euc < 128 then
			r << euc
		elsif euc > 0xa0 && euc < 0xdf then
			r << 0x8e
			r << (euc & 0xff)
		elsif euc >= 0x2121 && euc <= 0x6d63 then
			r << 0x8f
			r << ((euc >> 8) | 0x80)
			r << ((euc & 0xff) | 0x80)
		elsif euc != 0xffff then
			r << (euc >> 8)
			r << (euc & 0xff)
		end
	end
	r
end
